Projects/MIUBlog/MIUBlog/MIUBlog/Models/BlogListViewModel.cs
using MIUBlog.Entities.Concrete;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MIUBlog.WebUI
{
    public class BlogListViewModel
    {
        public IQueryable<Blog> Blogs { get; set; }
    }
}

Projects/MIUBlog/MIUBlog/MIUBlog/Controllers/BlogController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using MIUBlog.Business.Abstract;
using MIUBlog.Entities.Concrete;
using MIUBlog.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace MIUBlog.WebUI.Controllers
{
    public class BlogController : Controller
    {
        private IBlogService _blogService;
        private ICategoryService _categoryService;
        private ICommentService _commentService;
        private UserManager<ApplicationUser> _userManager;
        public BlogController(IBlogService blogService, ICategoryService categoryService, ICommentService commentService, UserManager<ApplicationUser> userManager)
        {
            _blogService = blogService;
            _categoryService = categoryService;
            _commentService = commentService;
            _userManager = userManager;
        }



        public IActionResult Index(int? id, string q)
        {
            var query = _blogService.GetAll().Where(i => i.isApproved);
            if (id != null)
            {
                query = _blogService.GetAll().Where(i => i.CategoryId == id);
            }
            if (!string.IsNullOrEmpty(q))
            {
                query = query.Where(i => EF.Functions.Like(i.Title, "%" + q + "%") || i.Description.ToLower().Contains(q.ToLower()) || i.Body.ToLower().Contains(q.ToLower()));
            }
            return View(query.OrderByDescending(i => i.Date));
        }
        [Authorize(Roles = "Admin")]
        public IActionResult List()
        {
            return View(_blogService.GetAll());
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Create()
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Create(Blog entity)
        {
            TempData["action"] = "Create";


            if (ModelState.IsValid)
            {
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;
                _blogService.Add(entity);
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Edit(int id)
        {
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");

            return View(_blogService.GetAll().Where(i => i.BlogId == id).FirstOrDefault());

        }

        public IActionResult Details(int id, Blog blg)
        {
            int blogId = id;
            if (id == 0)
            {
                blogId = blg.BlogId;
            }


            var blog = _blogService.Get(blogId);
            var comments = _commentService.GetAll()
                .Include(i => i.ApplicationUser)
                .Where(i => i.Blog.BlogId == blogId && i.isApproved == true);
            BlogModel model = new BlogModel()
            {
                Blog = blog,
                Comments = comments
            };
            return View(model);
        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task<IActionResult> Edit(Blog entity, IFormFile file)
        {
            if (ModelState.IsValid)
            {
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }


                _blogService.Update(entity);
                TempData["message"] = $"{entity.Title} güncellendi.";
                return RedirectToAction("List");
            }
            ViewBag.Categories = new SelectList(_categoryService.GetAll(), "CategoryId", "Name");
            return View(entity);
        }
        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult Delete(int id)
        {
            var result = _blogService.GetAll().Where(i => i.BlogId == id).FirstOrDefault();
            TempData["message"] = $"{result.Title } Silmek İstediğinizden Eminmisiniz";


            return View(result);
        }
        [HttpPost, ActionName("Delete")]
        [Authorize(Roles = "Admin")]
        public IActionResult DeleteConfirmate(int BlogId)
        {
            try
            {
                var result = _blogService.GetAll().Where(i => i.BlogId == BlogId).FirstOrDefault();
                TempData["message"] = $"{result.Title} Silindi";
                if (ModelState.IsValid)
                {
                    _blogService.Delete(BlogId);

                }

                return RedirectToAction("List");
            }
            catch (DbUpdateException e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = "Önce alt kayıtları silmelisiniz.";
                return View("Error", errorViewModel);
            }
            catch (Exception e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = e.Message;
                return View("Error", errorViewModel);
            }
        }

        [HttpGet]
        [Authorize(Roles = "Admin")]
        public IActionResult AddOrUpdate(int? id)
        {

            if (id == 0 || id == null)
            {

                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return View("Create");
            }
            else
            {
                TempData["action"] = "Update";
                ViewData["title"] = "Update";
                return View("Create", _blogService.GetAll().FirstOrDefault(i => i.BlogId == id));

            }


        }
        [HttpPost]
        [Authorize(Roles = "Admin")]
        public async Task< IActionResult> AddOrUpdate(Blog entity, IFormFile file)
        {
            if (entity.BlogId == 0)
            {
                if (file != null)
                {
                    var path = Path.Combine(Directory.GetCurrentDirectory(), "wwwroot/img", file.FileName);
                    using (var stream = new FileStream(path, FileMode.Create))
                    {
                        await file.CopyToAsync(stream);
                    }
                    entity.Image = file.FileName;
                }
                ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);
                entity.ApplicationUserId = user.Id;

                _blogService.Add(entity);
                ViewData["title"] = "Create";
                TempData["action"] = "Create";
                return RedirectToAction("List");
            }
            else
            {
                _blogService.Update(entity);
                ViewData["title"] = "Update";
                TempData["action"] = "Update";
                return RedirectToAction("List");
            }


        }
    }

}

Projects/MIUBlog/MIUBlog/MIUBlog/Controllers/CategoryController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using MIUBlog.Business.Abstract;
using MIUBlog.Entities.Concrete;
using MIUBlog.Models;

namespace TeknoFaydaBlog.WebUI.Controllers
{
    //[Authorize(Roles = "Admin")]
    public class CategoryController:Controller
    {
        private ICategoryService _categoryService;

        public CategoryController(ICategoryService categoryService)
        {
            _categoryService = categoryService;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult List()
        {
            return View(_categoryService.GetAll());
        }

        [HttpGet]
        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Category entity)
        {
            if (ModelState.IsValid)
            {
                _categoryService.Add(entity);
                return RedirectToAction("List");
            }
            return View(entity);
        }
        [HttpGet]
        public IActionResult Edit(int id)
        {
            return View(_categoryService.GetAll().Where(i => i.CategoryId == id).FirstOrDefault());
        }
        [HttpPost]
        public IActionResult Edit(Category entity)
        {
            if (ModelState.IsValid)
            {
                _categoryService.Update(entity);
                return RedirectToAction("List");
            }
            return View(entity);
        }
        public IActionResult Delete(int id)
        {
            try
            {
                var result = _categoryService.GetAll().Where(i => i.CategoryId == id).FirstOrDefault();
                if (ModelState.IsValid)
                {
                    TempData["message"] = $"{result.Name} Silindi.";
                    _categoryService.Delete(id);
                }

                return RedirectToAction("List");
            }
            catch (DbUpdateException e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = "Önce alt kayıtları silmelisiniz.";
                return View("Error", errorViewModel);
            }
            catch (Exception e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = e.Message;
                return View("Error", errorViewModel);
            }
        }
    }
}

Projects/MIUBlog/MIUBlog/MIUBlog/Controllers/CommentController.cs
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using MIUBlog.Business.Abstract;
using MIUBlog.Entities.Concrete;
using MIUBlog.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace MIUBlog.WebUI.Controllers
{
    public class CommentController:Controller
    {
        private IBlogService _blogService;
        private IDiscussionService _discussionService;
        private IProjectService _projectService;
        private ICommentService _commentService;
        private UserManager<ApplicationUser> _userManager;

        public CommentController(IBlogService blogService,
            ICommentService commentService,
            UserManager<ApplicationUser> userManager,
            IDiscussionService discussionService,
            IProjectService projectService
            )
        {
            _blogService = blogService;
            _commentService = commentService;
            _userManager = userManager;
            _discussionService = discussionService;
            _projectService = projectService;
        }
        //[Authorize(Roles = "Admin")]
        public IActionResult Index()
        {
            var comments = _commentService.GetAll().AsQueryable()
                .Include(i => i.Blog)
                .Include(i => i.ApplicationUser)
                .Include(i => i.Discussion)
                .Include(i => i.Project)
                .Where(i => i.isApproved == false);
            return View(comments);
        }
        
            public async Task<IActionResult> CreateProjectComment(int projectId, string commentText)
        {
            var user = await _userManager.FindByNameAsync(User.Identity.Name);
            var project = _projectService.Get(projectId);
            Comment comment = new Comment();
            comment.Project = project;
            comment.ApplicationUser = user;
            comment.Date = DateTime.Now;
            comment.CommentText = commentText;
            _commentService.Add(comment);
            int id = project.Id;
            return RedirectToAction("Details", "Project", new Discussion() { Id = id });
        }
        public async Task<IActionResult> CreateDiscussionComment(int discussionId, string commentText)
        {
            var user = await _userManager.FindByNameAsync(User.Identity.Name);
            var discussion = _discussionService.Get(discussionId);
            Comment comment = new Comment();
            comment.Discussion = discussion;
            comment.ApplicationUser = user;
            comment.Date = DateTime.Now;
            comment.CommentText = commentText;
            _commentService.Add(comment);
            int id = discussion.Id;
            return RedirectToAction("Details", "Discussion", new Discussion() { Id = id });
        }

        public async Task<IActionResult> Create(int blogId, string commentText)
        {
            var user = await _userManager.FindByNameAsync(User.Identity.Name);
            var blog = _blogService.GetAll().FirstOrDefault(i => i.BlogId == blogId);
            Comment comment = new Comment();
            comment.Blog = blog;
            comment.ApplicationUser = user;
            comment.Date = DateTime.Now;
            comment.CommentText = commentText;
            _commentService.Add(comment);
            int id = blog.BlogId;
            return RedirectToAction("Details", "Blog", new Blog() { BlogId = blogId });
        }
        //[Authorize(Roles = "Admin")]
        public IActionResult Details(int id)
        {
            var comment = _commentService.GetAll().AsQueryable()
                .Include(i => i.Blog)
                .Include(i => i.ApplicationUser)
                .Include(i => i.Discussion)
                .Include(i => i.Project)
                .FirstOrDefault(i => i.CommentId == id);
            return View(comment);
        }
        //[Authorize(Roles = "Admin")]
        public IActionResult isApprovedMessages()
        {
            var comments = _commentService.GetAll().AsQueryable()
                .Include(i => i.Blog)
                .Include(i => i.ApplicationUser)
                .Include(i =>i.Discussion)
                .Include(i => i.Project)
                .Where(i => i.isApproved == true);
            return View(comments);
        }

        [HttpPost]
        //[Authorize(Roles = "Admin")]
        public IActionResult Update(int CommentId, bool isApproved)
        {
            var comment = _commentService.GetAll().FirstOrDefault(i => i.CommentId == CommentId);
            if (ModelState.IsValid)
            {
                comment.isApproved = isApproved;
                _commentService.Update(comment);
                return RedirectToAction("Index");
            }
            else
            {
                ModelState.AddModelError("", "Güncelleme işlemi yapılamadı");
            }

            return View(comment);


        }
        //[Authorize(Roles = "Admin")]
        public IActionResult Delete(int id)
        {
            try
            {
                _commentService.Delete(id);
                return RedirectToAction("Index");
            }
            catch (DbUpdateException e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = "Önce alt kayıtları silmelisiniz.";
                return View("Error", errorViewModel);
            }
            catch (Exception e)
            {
                ErrorViewModel errorViewModel = new ErrorViewModel();
                errorViewModel.ErrorMessage = e.Message;
                return View("Error", errorViewModel);
            }
        }
    }
}

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_BlogList.cshtml
@model IEnumerable<Blog>
@{
    int index = 0;
}

@if (Model.Count() == 0)
{
    <div class="alert-warning"> Kayıt Yok</div>


}
else
{
    

        <div class="row text-center">
            @foreach (var item in Model)
            {
                <div class="card m-2" style="width: 25rem;">
                    <div class="card-header">
                    </div>
                    <img class="card-img-top" src="~/img/@item.Image" alt="Card image cap">

                    <div class="card-block"  >
                        <h4 class="card-title">@item.Title</h4>
                        <p class="card-text">@item.Description</p>
                        <a asp-controller="Blog" asp-action="Details" asp-route-id="@item.BlogId" class="btn btn-primary">keep reading <i class="fas fa-arrow-right"></i></a>
                        
                    </div>
                </div>
            }
        </div>

}

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_DiscussionList.cshtml
@model IEnumerable<Discussion>
@{
    int index = 0;
}

@if (Model.Count() == 0)
{
    <div class="alert-warning"> Kayıt Yok</div>


}
else
{


    <div class="row text-center">
        @foreach (var item in Model)
        {
            <div class="card m-2" style="width: 25rem;">
                <div class="card-header">
                </div>
                <img class="card-img-top" src="~/img/@item.Image" alt="Card image cap">

                <div class="card-block">
                    <h4 class="card-title">@item.Title</h4>
                    <p class="card-text">@item.Description</p>
                    <a asp-controller="Discussion" asp-action="Details" asp-route-id="@item.Id" class="btn btn-primary">keep reading <i class="fas fa-arrow-right"></i></a>

                </div>
            </div>
        }
    </div>

}

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css">
    <link rel="stylesheet" href="/modules/bootstrap/dist/css/bootstrap.min.css" crossorigin="anonymous">
    @RenderSection("Css", false)
    <link rel="stylesheet" href="~/css/style.css">
    <script src="https://kit.fontawesome.com/c26b6bd05e.js" crossorigin="anonymous"></script>
    <title>MIUBlog</title>
</head>
<body>

    @await Html.PartialAsync("_navbar")

    <main class="my-3">
        <div class="container">



            @RenderBody()
        </div>
    </main>
    <div style="bottom:0;position:fixed; width:100%;">

        <footer class="py-2 bg-dark text-white text-center">
            © 2021 MIU Tech. Software. Tüm hakları saklıdır.
        </footer>
     </div>
        <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
        @RenderSection("Scripts", false)
</body>
</html>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_ProjectList.cshtml
@model IEnumerable<Project>
@{
    int index = 0;
}

@if (Model.Count() == 0)
{
    <div class="alert-warning"> Kayıt Yok</div>


}
else
{


    <div class="row text-center">
        @foreach (var item in Model)
        {
            <div class="card m-2" style="width: 25rem;">
                <div class="card-header">
                </div>
                <img class="card-img-top" src="~/img/@item.Image" alt="Card image cap">

                <div class="card-block">
                    <h4 class="card-title">@item.Title</h4>
                    <p class="card-text">@item.Description</p>
                    <a asp-controller="Project" asp-action="Details" asp-route-id="@item.Id" class="btn btn-primary">keep reading <i class="fas fa-arrow-right"></i></a>

                </div>
            </div>
        }
    </div>

}

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_ResultMessage.cshtml
@model AlertMessage

<div class="row">
    <div class="col-md-12">
        <div class="alert alert-@Model.AlertType">
            <h4 class="alert-title">@Model.Title</h4>
            <p>@Model.Message</p>
        </div>
    </div>
</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_Slider.cshtml
@model IEnumerable<Blog>
<div id="carouselExampleIndicators" class="carousel slide mb-3" data-ride="carousel">
    <ol class="carousel-indicators">
        @for (int i = 0; i < Model.Count(); i++)
        {
            if (i == 0)
            {
                <li data-target="#carouselExampleIndicators" data-slide-to="@i" class="active"></li>
            }
            else
            {
                <li data-target="#carouselExampleIndicators" data-slide-to="@i"></li>
            }
        }
    </ol>
    <div class="carousel-inner" role="listbox">
        @{ var index = 0;}
        @foreach (var item in Model)
        {
            if (index == 0)
            {
                <div class="carousel-item active">
                    <a href="Blog/Details/@item.BlogId"><img class="d-block img-fluid" src="~/img/@item.Image" alt="@item.Title"></a>
                    <div class="carousel-caption d-none d-md-block">
                        <h3>@item.Title</h3>
                        <p>@item.Description</p>
                    </div>
                </div>
                index++;
            }
            else
            {
                <div class="carousel-item">
                    <a href="Blog/Details/@item.BlogId"><img class="d-block img-fluid" src="~/img/@item.Image" alt="@item.Title"></a>

                    <div class="carousel-caption d-none d-md-block">
                        <h3>@item.Title</h3>
                        <p>@item.Description</p>
                    </div>
                </div>
            }

        }


        <a class="carousel-control-prev" href="#carouselExampleIndicators" role="button" data-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="sr-only">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carouselExampleIndicators" role="button" data-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="sr-only">Next</span>
        </a>
    </div>
</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_categories.cshtml
 @model List<Category>
 
 <div class="list-group">
    @foreach (var category in Model)
    {
        <a href="#" class="list-group-item list-group-item-action">@category.Name</a>
    }
</div>   

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_header.cshtml
 <header>
        <div class="jumbotron jumbotron-fluid">
            <div class="container">
                <h1 class="display-4">MIUBlog</h1>
                <p class="lead">Lorem ipsum dolor sit amet consectetur adipisicing elit. Doloremque id, eum explicabo sed est hic corrupti et impedit, quasi quis alias, qui provident natus enim tempore? Nesciunt repellendus debitis minus!</p>
            </div>
        </div>
    </header>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_navbar.cshtml
<div class="navbar bg-primary navbar-dark navbar-expand-sm">
    <div class="container">
        <a class="navbar-brand" asp-action="Index" asp-controller="Home">GroupFlow</a>
        <ul class="navbar-nav mr-auto">
            <li class="nav-item">
                <a class="nav-link" href="/blog">
                    <i class="far fa-newspaper"></i>&nbsp;Blogs
                </a>
            </li>
            <li class="nav-item">
                <a class="nav-link" asp-controller="Discussion" asp-action="Index"><i class="far fa-comments"></i>&nbsp;Discussions</a> <!--sor-->
            </li>
            <li class="nav-item">
                <a class="nav-link" asp-controller="Project" asp-action="Index"><i class="fas fa-laptop-code"></i>&nbsp;Project</a>  <!--sor-->
            </li>

            @if (User.Identity.IsAuthenticated)
            {





                @if (User.IsInRole("Admin"))
                {

                    <li class="nav-item">
                        <a class="nav-link"><i class="fas fa-grip-lines-vertical"></i></a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Blog" asp-action="List">Blogs</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Discussion" asp-action="List">Discussion</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Project" asp-action="List">Project</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Category" asp-action="List">Categories</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Admin" asp-action="UserList">Users</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Admin" asp-action="RoleList">Roles</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Comment" asp-action="Index">Comments</a>
                    </li>

                }
                @if (User.IsInRole("User"))
                {

                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Project" asp-action="UserProjectList">ProjectList</a>
                    </li>
                  <!--  <li class="nav-item">
                        <a class="nav-link" asp-controller="Discussion" asp-action="UserProjectList">DisList</a>
                    </li> 
                   -->

                }
            }

        </ul>

        <ul class="navbar-nav ml-auto">

            @if (User.Identity.IsAuthenticated)
            {
                <li class="nav-item">
                    <a asp-action="userprofile" asp-controller="admin" asp-route-name="@User.Identity.Name" class="nav-link">
                        @User.Identity.Name
                    </a>
                </li>
                <li class="nav-item">
                    <a href="/account/logout" class="nav-link">Logout</a>
                </li>
            }
            else
            {
                <li class="nav-item">
                    <a href="/account/login" class="nav-link">Login</a>
                </li>
                <li class="nav-item">
                    <a href="/account/register" class="nav-link">Register</a>
                </li>

            }
        </ul>


    </div>
</div>

Projects/MIUBlog/MIUBlog/MIUBlog/Views/Shared/_search.cshtml
  <div class="card mt-3">
      <div class="card-header">
          <h5>Search</h5>
      </div>
      <div class="card-body">
            <form action="/search">
                <div class="form-group">
                    <input name="q" type="text" class="form-control" placeholder="Search">
                </div>
                <button type="submit" class="btn btn-danger btn-sm btn-block">Ara</button>
            </form>
      </div>
  </div>
  
  